unit UMainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UBaseForm, ComCtrls, StdCtrls, StdActns, ActnList, Menus, Mask,
  ExtCtrls, ShellApi, jpeg;

Type

  TMaskEdits = array of TMaskEdit;

  TMainForm = class(TBaseForm)
                                            {Menu bar}
    ActionList1: TActionList;
    InputOpen: TAction;
    InputSave: TAction;
    OutputOpen: TAction;
    GraphOpen: TAction;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    InputOpen1: TMenuItem;
    InputSave1: TMenuItem;
    OpenOutput1: TMenuItem;
    GraphOpen1: TMenuItem;
    ProgramExit: TMenuItem;
    Edit: TMenuItem;
    Cut: TMenuItem;
    Copy: TMenuItem;
    Paste: TMenuItem;
    Delete: TMenuItem;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditDelete1: TEditDelete;
    EditPaste1: TEditPaste;
    FileExit1: TFileExit;
    PageControl1: TPageControl;
                                            {Intro tabsheet}
    Intro_Tabsheet: TTabSheet;
    Intro_Memo: TMemo;
    LogoImage: TImage;
                                            {Input tabsheet}
    Input_TabSheet: TTabSheet;
    Filesave_Button: TButton;
    Fileopen_Button: TButton;
    FigureButton1: TButton;
    Filename_Label: TLabel;
    Title1_Label: TLabel;
    Title2_Label: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Options_Label: TLabel;
    Method_Label: TLabel;
    CalcAim_Combobox: TComboBox;
    Method_ComboBox: TComboBox;
    InputOpen_Dialog: TOpenDialog;
    InputSave_Dialog: TSaveDialog;
    FileName_Edit: TEdit;
    Title1_Edit: TEdit;
    Title2_Edit: TEdit;
                                            {Figure tabsheet}
    Figure_TabSheet: TTabSheet;
    Figure_Image: TImage;
                                            {Output tabsheet}
    Output_TabSheet: TTabSheet;
    Output_Memo: TMemo;
    OutputOpen_Dialog: TOpenDialog;
    Symbols_Memo: TMemo;
    Joule_Image: TImage;
    SeeOutput_Button: TButton;
    Symbols_Button: TButton;
    FigureButton2: TButton;
                                           {Graphics tabsheet}
    Graphics_TabSheet: TTabSheet;
    MakeGraphics_Button: TButton;
    SaveGraphButton: TButton;
    SeeGraphButton: TButton;
    GraphOpen_Dialog: TOpenDialog;
    GraphSave_Dialog: TSaveDialog;
    JouleImage2: TImage;
    ViewGraphButton: TButton;
    WaitMemo: TMemo;
    HelpButton: TButton;
    GraphImage: TImage;
    PictureImage: TImage;
    RechargeButton: TButton;
    BlWhButton: TButton;
         {General}
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Intro_TabsheetShow(Sender: TObject);
        {Input}
    procedure Input_TabSheetShow(Sender: TObject);
    procedure InputOpenExecute(Sender: TObject);
    procedure CalcAim_ComboboxChange(Sender: TObject);
    procedure Method_ComboBoxChange(Sender: TObject);
    function  StringToFloat(Str : string) : double;
    procedure MaskEdit1Exit(Sender: TObject);
    procedure MaskEdit2Exit(Sender: TObject);
    procedure InputSaveExecute (Sender: TObject);
    procedure FigureButton1Click(Sender: TObject);
        {Figure}
    procedure Figure_TabSheetShow(Sender: TObject);
        {Output}
    procedure Output_TabSheetShow(Sender: TObject);
    procedure OutputOpenExecute(Sender: TObject);
    procedure MakeGraphics_ButtonClick(Sender: TObject);
    procedure CloseOutput_ButtonClick(Sender: TObject);
    procedure Symbols_ButtonClick(Sender: TObject);
    procedure FigureButton2Click(Sender: TObject);
    procedure GraphOpenExecute(Sender: TObject);
        {Finish}
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure SaveGraphButtonClick(Sender: TObject);
    procedure Graphics_TabSheetShow(Sender: TObject);
    procedure Input_TabSheetExit(Sender: TObject);
    procedure ViewGraphButtonClick(Sender: TObject);
    procedure HelpButtonClick(Sender: TObject);
    procedure RechargeButtonClick(Sender: TObject);
    procedure BlWhButtonClick(Sender: TObject);

  private

       {Input}
    DepthM, Recharge,
    Spacing, HorCondA,
    HorCond1, VertCond1,
    HorCond2, DepthD,
    DepthW, DepthI,
    Depth1, VertCond2,
    ResE, WidthW             : string;
    AimOfCalc,
    PrevAimOfCalc            : word;
    NoSave, OutputOpened,
    InputOpened, GraphOpened,
    RunTimeError, Color      : boolean;
    MaskEdit                 : TMaskEdits;     {array van TMaskEdit}
    InitDecSep               : char;

       {Input}
    procedure SetInitialValues;
    procedure SetDataLineStandards;
    procedure AdjustValues;
    procedure AdjustStrings;
    function  SetAndVerifySaveName : boolean;
    procedure DoCalculations;
    procedure SetInitialDir (AuxDir:string);
    procedure Resettings;
    procedure WipeErrorFile;

      {Graphics}
    procedure Show_Graphics;

  public

  end;

var
  MainForm: TMainForm;

implementation

uses UDMEnDrain, UCloseForm, UEnDrainUtils, UFigureForm, UHelpForm,
     URechargeForm, USpacing, UConduct, UHydHead, UDischarge;

{$R *.dfm}

{******************************************************************************
 Introduction TabSheet
 ******************************************************************************}

procedure TMainForm.Intro_TabsheetShow(Sender: TObject);
begin
  inherited;
  StatusText ('Use the Input tabsheet to continue');
  FigureForm.Visible := false;
end;

{******************************************************************************
 Input TabSheet
 ******************************************************************************}

procedure TMainForm.Input_TabSheetShow(Sender: TObject);
{------------------------------------------------------}
begin Inherited;
      StatusText('Enter data or use "Open" to see examples under' +
            ' "Data" or to edit existing files. Thereafter use' +
            ' "Save/Run".');
      InputSave.Enabled := true;
      if not InputOpened then
      begin
        DMEnDrain.Code:='Spa';
        CalcMethod:='Energ';
      end;
end; {TMainForm.Input_TabSheetShow}
{---------------------------------}

{See also InputOpenExecute in Group MenuBar Buttons}

procedure TMainForm.SetDataLineStandards;
{---------------------------------------}
var k: integer;
    SpareCaption             : string;
begin
  Label1.Caption:= 'Time average recharge or discharge         R    (m/day) :';
  Label2.Caption:= 'Bottom depth of 1st layer below s.s.       D1       (m) :';
  Label3.Caption:= 'Bottom depth of 2nd layer below s.s.       D2       (m) :';
  Label4.Caption:= 'Depth water level in drain below s.s.      Dw       (m) :';
  Label5.Caption:= 'Depth of the drain bottom below s.s.       Db       (m) :';
  Label6.Caption:= 'Entrance resistance at the drain           E    (day/m) :';
  Label7.Caption:= 'Max. width of water body in the drain      W        (m) :';
  Label8.Caption:= 'Hydraulic permeability, above drain level  Ka   (m/day) :';
  Label9.Caption:= 'Horizontal permeability, 1st soil layer    Kb1  (m/day) :';
  Label10.Caption:='Vertical permeability, 1st soil layer      Kv1  (m/day) :';
  Label11.Caption:='Horizontal permeability, 2nd soil layer    Kb2  (m/day) :';
  Label12.Caption:='Vertical permeability, 2nd soil layer      Kv2  (m/day) :';
  Label13.Caption:='Depth watertable midway between drains *)  Dm       (m) :';
  SpareCaption :=  'Spacing between the parallel drains        S        (m) :';
  label14.Caption:='*) Time average';
  Label1.Visible:=true;
  Label2.Visible:=true;
  Label3.Visible:=true;
  Label4.Visible:=true;
  Label5.Visible:=true;
  Label6.Visible:=true;
  Label7.Visible:=true;
  Label8.Visible:=true;
  Label9.Visible:=true;
  Label10.Visible:=true;
  Label11.Visible:=true;
  Label12.Visible:=true;
  Label13.Visible:=true;
  Label14.Visible:=true;
  for k:=1 to 13 do MaskEdit[k-1].Visible:=true;
  if AimOfCalc=0 then                              {Spacing}
  begin
    Label14.Visible:=true;
  end;
  if AimOfCalc=1 then                              {Discharge}
  begin
    Label14.Visible:=true;
    Label1.Caption:=Label13.Caption;
    Label13.Caption :=SpareCaption;
  end;
  if AimOfCalc=2 then                               {Depth}
  begin
    Label13.Caption :=SpareCaption;
    Label14.Visible :=false;
  end;
  if AimOfCalc=3 then                               {Conductivity}
  begin
    Label1.Visible:=false;
    Label2.Visible:=false;
    MaskEdit[0].Visible:=false;
    MaskEdit[1].Visible:=false;
    Label8.Caption:=Label7.Caption;
    Label7.Caption:=Label6.Caption;
    Label6.Caption:=Label5.Caption;
    Label5.Caption:=Label4.Caption;
    Label4.Caption:=Label3.Caption;
    Label3.Caption:=Label1.Caption;
    Label4.Caption:='Bottom depth of 2nd layer below s.s.       D2       (m) :';
    Label9.Caption:=Label13.Caption;
    Label10.Caption:=SpareCaption;
    Label11.Visible:=false;
    Label11.Caption:=Label14.Caption;
//   Label12.Visible:=false;
    Label12.Caption:=Label14.Caption;
    Label13.Visible:=false;
    Label14.Visible:=false;
    for k:=11 to 13 do MaskEdit[k-1].Visible:=false;
  end;
end; {TMainForm.SetDataLineStandards}
{-----------------------------------}



procedure TMainForm.SetInitialValues;
{-----------------------------------}
{var i : integer;}
begin
  if AimOfCalc=0 then                 {Calculate 'Spa'cing}
  begin
    Recharge:=MaskEdit[0].Text;
    DepthM:=MaskEdit[12].Text;
    Spacing:='-1';
  end;
  if AimOfCalc=1 then                 {Calculate Recharge or 'Dis'charge}
  begin
    DepthM:=MaskEdit[0].Text;
    Spacing:=MaskEdit[12].Text;
    Recharge:='-1';
  end;
  if AimOfCalc=2 then                 {Calculate Depth or 'Hyd'raulic head}
  begin
    Recharge:=MaskEdit[0].Text;
    Spacing:=MaskEdit[12].Text;
    DepthM:='-1';
   end;
  if AimOfCalc=3 then                 {Calculate 'Con'ductivity}
  begin
    Recharge:=MaskEdit[0].Text;
    DepthI:=MaskEdit[1].Text;
    DepthW:=MaskEdit[2].Text;
    DepthD:=MaskEdit[3].Text;
    ResE:=MaskEdit[4].Text;
    WidthW:=MaskEdit[5].Text;
    DepthM:=MaskEdit[6].Text;
    Spacing:=MaskEdit[7].Text;
    if Spacing='0'then Spacing:='-1';
    MaskEdit[9].Text:=MaskEdit[7].Text;
    MaskEdit[8].Text:=MaskEdit[6].Text;
    MaskEdit[7].Text:=MaskEdit[5].Text;
    MaskEdit[6].Text:=MaskEdit[4].Text;
    MaskEdit[5].Text:=MaskEdit[3].Text;
    MaskEdit[4].Text:=MaskEdit[2].Text;
    MaskEdit[3].Text:=MaskEdit[1].Text;
    MaskEdit[2].Text:=MaskEdit[0].Text;
  end;
  if AimOfCalc<3 then
  begin
    Depth1:=MaskEdit[1].Text;
    DepthI:=MaskEdit[2].Text;
    DepthW:=MaskEdit[3].Text;
    DepthD:=MaskEdit[4].Text;
    ResE:=MaskEdit[5].Text;
    WidthW:=MaskEdit[6].Text;
    HorCondA:=MaskEdit[7].Text;
    HorCond1:=MaskEdit[8].Text;
    VertCond1:=MaskEdit[9].Text;
    HorCond2:=MaskEdit[10].Text;
    VertCond2:=MaskEdit[11].Text;
  end;
  PrevAimOfCalc:=AimOfCalc;
end; {TMainForm.SetInitialValues}
{-------------------------------}



procedure TMainForm.AdjustStrings;
{--------------------------------}
begin
  MaskEdit[1].Text:=Depth1;
  if Depth1='' then MaskEdit[1].Text:='0';
  MaskEdit[2].Text:=DepthI;
  if DepthI='' then MaskEdit[2].Text:='0';
  MaskEdit[3].Text:=DepthW;
  if DepthW='' then MaskEdit[3].Text:='0';
  MaskEdit[4].Text:=DepthD;
  if DepthD='' then MaskEdit[4].Text:='0';
  MaskEdit[5].Text:=ResE;
  if ResE='' then MaskEdit[5].Text:='0';
  MaskEdit[6].Text:=WidthW;
  if WidthW='' then MaskEdit[6].Text:='0';
  MaskEdit[7].Text:=HorCondA;
  if HorCondA='' then MaskEdit[7].Text:='0';
  MaskEdit[8].Text:=HorCond1;
  if HorCond1='' then MaskEdit[8].Text:='0';
  MaskEdit[9].Text:=VertCond1;
  if VertCond1='' then MaskEdit[9].Text:='0';
  MaskEdit[10].Text:=HorCond2;
  if HorCond2='' then MaskEdit[10].Text:='0';
  MaskEdit[11].Text:= VertCond2;
  if VertCond2='' then MaskEdit[11].Text:='0';
  if AimOfCalc=0 then
  begin
    MaskEdit[0].Text:=Recharge;
    MaskEdit[12].Text:=DepthM;
   end else
   if AimOfCalc=1 then
   begin
     MaskEdit[0].Text:=DepthM;
     MaskEdit[12].Text:=Spacing;
   end else
   if AimOfCalc=2 then
   begin
     MaskEdit[0].Text:=Recharge;
     MaskEdit[12].Text:=Spacing;
   end;
end; {TMainForm.AdjustStrings}
{----------------------------}



procedure TMainForm.CalcAim_ComboboxChange(Sender: TObject);
{----------------------------------------------------------}
begin Inherited;
      AimOfCalc:=CalcAim_ComboBox.ItemIndex;
      SetDataLineStandards;
      DMEnDrain.Code := code_array[AimOfCalc];
      AdjustValues;
      RechargeButton.Enabled:=true;
      if AimOfCalc=1 then RechargeButton.Enabled:=false;
end; {TMainForm.CalcAim_ComboboxChange}
{-------------------------------------}



procedure TMainForm.AdjustValues;
{-------------------------------}
begin

  if AimOfCalc<2 then Label14.Visible:=true;
  if PrevAimOfCalc=0 then        {Calculate Spacing}
  begin
    if AimOfCalc=0 then
    begin
      MaskEdit[0].Text:=Recharge;                {Original Recharge}
      MaskEdit[12].Text:=DepthM;                 {Original Depth}
    end;
    if AimOfCalc=1 then
    begin
      MaskEdit[0].Text:=DepthM;                  {Depth interchanged}
      MaskEdit[12].Text:=Spacing;                {Spacing=0}
    end;
    if AimOfCalc=2 then
    begin
      MaskEdit[0].Text :=Recharge;               {Recharge unchanged}
      Maskedit[12].Text:=Spacing;                {Spacing=0}
    end;
    if AimOfCalc=3 then
    begin
      MaskEdit[2].Text:=Recharge;                {Recharge unchanged}
//      if Recharge='' then MaskEdit[2].Text:= '0';
      MaskEdit[3].Text:=DepthI;
//      if DepthI='' then MaskEdit[3].Text:= '0';
      MaskEdit[4].Text:=DepthW;
//      if DepthW='' then MaskEdit[4].Text:= '0';
      MaskEdit[5].Text:=DepthD;
//      if DepthD='' then MaskEdit[5].Text:= '0';
      MaskEdit[6].Text:=ResE;
//      if ResE='' then MaskEdit[6].Text:= '0';
      MaskEdit[7].Text:=WidthW;
//      if WidthW='' then MaskEdit[7].Text:= '0';
      MaskEdit[8].Text:=DepthM;                  {Original Depth}
//      if DepthM='' then MaskEdit[8].Text:= '0';
      MaskEdit[9].Text:=Spacing;                 {Spacing=0}
//      if Spacing='' then MaskEdit[8].Text:= '0';
    end;
  end; {if PrevAimOfCalc=0 then}

  if PrevAimOfCalc=1 then        {calculate Recharge or 'Dis'charge}
  begin
    if AimOfCalc=0 then
    begin
      MaskEdit[0].Text:=Recharge;
      MaskEdit[12].Text:=DepthM;
    end;
    if AimOfCalc=1 then
    begin
      MaskEdit[0].Text:=DepthM;
      MaskEdit[12].Text:=Spacing;
    end;
    if AimOfCalc=2 then
    begin
      MaskEdit[0].Text :=Recharge;
      MaskEdit[12].Text:=Spacing;
    end;
    if AimOfCalc=3 then
    begin
      MaskEdit[2].Text:=Recharge;
      MaskEdit[3].Text:=DepthI;
      MaskEdit[4].Text:=DepthW;
      MaskEdit[5].Text:=DepthD;
      MaskEdit[6].Text:=ResE;
      MaskEdit[7].Text:=WidthW;
      MaskEdit[8].Text:=DepthM;
      MaskEdit[9].Text:=Spacing;
    end;
  end; {if PrevAimOfCalc=1 then}

  if PrevAimOfCalc=2 then        {calculate 'Hyd'raulic head or Depth}
  begin
    if AimOfCalc=0 then
    begin
      MaskEdit[0].Text :=Recharge;
      MaskEdit[12].Text:=DepthM;
    end;
    if AimOfCalc=1 then
    begin
      MaskEdit[0].Text:=DepthM;
      MaskEdit[12].Text:=Spacing;
    end;
    if AimOfCalc=2 then
    begin
      Label14.Visible:=false;
      MaskEdit[0].Text:=Recharge;
      MaskEdit[12].Text:=Spacing;
    end;
    if AimOfCalc=3 then
    begin
      MaskEdit[2].Text:=Recharge;
      MaskEdit[3].Text:=DepthI;
      MaskEdit[4].Text:=DepthW;
      MaskEdit[5].Text:=DepthD;
      MaskEdit[6].Text:=ResE;
      MaskEdit[7].Text:=WidthW;
      MaskEdit[8].Text:=DepthM;
      MaskEdit[9].Text:=Spacing;
    end;
  end; {if PrevAimOfCalc=2 then}

  if PrevAimOfCalc=3 then                 {calculate 'Con'ductivity}
  begin
    AdjustStrings;
    if AimOfCalc<3 then
      if HorCondA<>'' then
      begin
        MaskEdit[1].Text:=Depth1;
        if Depth1='' then MaskEdit[1].Text:='0';
        MaskEdit[7].Text:=HorCondA;
        if HorCondA='' then MaskEdit[7].Text:='0';
        MaskEdit[8].Text:=HorCond1;
        if HorCond1='' then MaskEdit[8].Text:='0';
        MaskEdit[9].Text:=VertCond1;
        if VertCond1='' then MaskEdit[9].Text:='0';
        MaskEdit[10].Text:=HorCond2;
        if HorCond2='' then MaskEdit[10].Text:='0';
        MaskEdit[11].Text:=VertCond2;
        if VertCond2='' then MaskEdit[11].Text:='0';
      end;
    if AimOfCalc=0 then
    begin
      MaskEdit[0].Text :=Recharge;
      MaskEdit[12].Text:=DepthM;
    end;
    if AimOfCalc=1 then
    begin
      MaskEdit[0].Text:=DepthM;
      MaskEdit[12].Text:=Spacing;
    end;
    if AimOfCalc=2 then
    begin
      MaskEdit[0].Text:=Recharge;
      MaskEdit[12].Text:=Spacing;
    end;
    if AimOfCalc=3 then
    begin
      MaskEdit[2].Text:=Recharge;
      MaskEdit[9].Text:=DepthM;
      MaskEdit[10].Text:=Spacing;
    end;
  end; {if PrevAimOfCalc=3 then}
  PrevAimOfCalc:=AimOfCalc;
end; {TMainForm.AdjustValues}
{---------------------------}



function TMainForm.StringToFloat(Str : string) : double;
{------------------------------------------------------}
{accepts comma or point for decimal separator}
var
  OldDecSep : char;
begin
  try
    Result := StrToFloat(Str);
  except
    on EConvertError do begin
      OldDecSep := DecimalSeparator;
      {change to other decimal separator}
      if DecimalSeparator = ',' then
        DecimalSeparator := '.'
      else
        DecimalSeparator := ',';
      Result := StrToFloat(Str);
      {revert to original decimal separator}
      DecimalSeparator :=     OldDecSep;
    end;
  end;
end; {TSegRegForm.StringToFloat}
{------------------------------}



procedure TMainForm.MaskEdit1Exit(Sender: TObject);
{-------------------------------------------------}
begin Inherited;
      Try
         begin                                   {test of het echt een real is}
           (Sender as TMaskEdit).Text :=
               FloatToStr(StringToFloat((Sender as TMaskEdit).Text));
         end;
         Except on E: exception do
         begin ShowMessage
               ((Sender as TMaskEdit).Text + ' is not a valid real number');
               (Sender as TMaskEdit).Text := '0';
               DecimalSeparator := InitDecSep;
         end;
      end;
end; {TMainForm.MaskEdit1Exit}
{----------------------------}



procedure TMainForm.MaskEdit2Exit (Sender:TObject);
var D1,D2:real;
begin
      Try
            begin                               {test of het echt een real is}
                 (Sender as TMaskEdit).Text :=
                    FloatToStr(StringToFloat((Sender as TMaskEdit).Text));
            end;
      Except on E: exception do
            begin ShowMessage
                  ((Sender as TMaskEdit).Text + ' is not a valid real number');
                  (Sender as TMaskEdit).Text := '0';
                  DecimalSeparator := InitDecSep;
                  exit;
            end;
      end;
  D1:=StringToFloat(MaskEdit[1].Text);
  D2:=StringToFloat(MaskEdit[2].Text);
  if (DMEnDrain.Code<>'Con') and (D1=D2) and (D2>0) then showmessage
                ('When D1 and D2 are equal, there is only one layer. '+
                 'The values of Kb2 and Kv2 are immaterial.');
end; {TMainForm.MaskEdit2Exit}



function TMainForm.SetAndVerifySaveName;
begin Inherited;
      NoSave:=false;
      Result := false;
      if InputSave_Dialog.Execute then with DMEnDrain do
      begin FileName := InputSave_Dialog.Files.Strings[0];
        if FileExists(FileName)
        then  Result :=
              Question('The file already exists, overwrite?')
        else  Result := true;
      end
      else NoSave:=true;
end; {TMainForm.SetAndVerifySaveName}
{-----------------------------------}



procedure TMainForm.Method_ComboBoxChange(Sender: TObject);
begin
  inherited;
  CalcMethod:='Energ';
  if Method_ComboBox.ItemIndex=1 then CalcMethod:='Darcy';
end; {TMainForm.Method_ComboBoxChange}
{------------------------------------}



procedure TMainForm.FigureButton1Click(Sender: TObject);
begin
  inherited;
  FigureForm.Visible:=true;
end; {TMainForm.FigureButton1Click}
{---------------------------------}


procedure TMainForm.RechargeButtonClick(Sender: TObject);
begin
  inherited;
  RechargeForm.show;
end; {TMainForm.RechargeButtonClick}
{----------------------------------}


procedure TMainForm.HelpButtonClick(Sender: TObject);
begin
  inherited;
  HelpForm.show;
end; {TMainForm.HelpButtonClick}
{------------------------------}



procedure TMainForm.DoCalculations;
{---------------------------------}

begin
  WaitMemo.Visible:=true;
  WaitMemo.Lines.Clear;
  WaitMemo.Lines.Add(' Saving input ....');
  Sleep(500);
  RunTimeError:=false;
  with DMEnDrain do
  begin
    if (Code='Spa') then
    begin
      CheckSpacingData;
      CalcDone := true;
      if InputError then
      begin
        Resettings;
        exit;
      end;
      WipeErrorFile;
      if (CalcMethod='Darcy') then DarSpac;
      if (CalcMethod='Energ') then EneSpac;
      WaitMemo.Lines.Add(' Writing output ..');
      Sleep(500);
    end else
    if (Code='Dis') then
    begin
      CheckDiscData;
      CalcDone := true;
      if InputError then
      begin
        Resettings;
        exit;
      end;
      WipeErrorFile;
      if (CalcMethod='Darcy') then DarDisc;;
      if (CalcMethod='Energ') then EneDisc;;
      WaitMemo.Lines.Add(' Writing output ..');
      Sleep(500);
//        ExeFileName:='DarDisc.exe'
    end else
    if (Code='Con') then
    begin
      CheckConductData;
      CalcDone := true;
      if InputError then
      begin
        Resettings;
        exit;
      end;
      WipeErrorFile;
      if (CalcMethod='Darcy') then DarCond;
      if (CalcMethod='Energ') then EneCond;
      WaitMemo.Lines.Add(' Writing output ..');
      Sleep(500);
    end
    else
    if (Code='Hyd') then
    begin
      CheckHeadData;
      CalcDone := true;
      if InputError then
      begin
        Resettings;
        exit;
      end;
      WipeErrorFile;
      HydrHead;
      WaitMemo.Lines.Add(' Writing output ..');
      Sleep(500);
    end else
    begin
      Showmessage ('The run file could not be found or opened.' +
                   '  No calculations were made.');
      exit;
    end;

  end; {with DMEnDrain do}
end; {TMainForm.DoCalculations}
{-----------------------------}



procedure TMainForm.SetInitialDir (AuxDir:string);
{------------------------------------------------}
begin
  MainForm.InputOpen_Dialog.InitialDir:=AuxDir;
  MainForm.InputSave_Dialog.InitialDir:=AuxDir;
  MainForm.OutputOpen_Dialog.InitialDir:=AuxDir;
end; {TMainForm.SetInitialDir}
{----------------------------}



procedure TMainForm.Resettings;
{-----------------------------}
var ErrorFile : textfile;
begin
  with MainForm do
  begin
    Assignfile (ErrorFile,'Error.lst');
    reset (ErrorFile);
    OutputOpened:=false;
    FigureForm.Visible:=false;
    FigureButton2.Visible:=false;
    WaitMemo.Visible:=false;
    RunTimeError:=true;
    deletefile (DMEnDrain.FileName);
    Output_Tabsheet.Show;
  end;
end; {procedure Resettings}
{--------------------------}



procedure TMainForm.WipeErrorFile;
{--------------------------------}
begin
  with MainForm do
  begin
    deletefile ('Error.lst');
    WaitMemo.Lines.Add(' Calculating .....');
    Sleep(500);
    WaitMemo.Lines.Add(' Please wait .....');
    Sleep(500);
  end;
end; {procedure VErrorFile}
{-------------------------}



procedure TMainForm.Input_TabSheetExit(Sender: TObject);
{------------------------------------------------------}
begin
  inherited;
  InputSave.Enabled := false;
end; {TMainForm.Input_TabSheetExit}
{---------------------------------}


{See also FileSaveExecute in Group MenuBar Buttons}


{******************************************************************************
 End of Input Tabsheet, start of Figure TabSheet
 ******************************************************************************}


procedure TMainForm.Figure_TabSheetShow(Sender: TObject);
{-------------------------------------------------------}
begin Inherited;
    StatusText ('The figure gives explanations of symbols used in the' +
                ' input tabsheet');
    FigureForm.Visible:=false;
end;{TMainForm.Figure_TabSheetShow}
{---------------------------------}


{******************************************************************************
 End of Figure Tabsheet, start of Output TabSheet
 ******************************************************************************}


procedure TMainForm.Output_TabSheetShow(Sender: TObject);
{-------------------------------------------------------}
var k : integer;
    ErrorFileName, TextLine : string;
    ErrorFile : textFile;
begin Inherited;

      StatusText ('The output file can be inspected. Use "See output"' +
                  ' to see examples under "Data" or to inspect any other' +
                  ' output file.');
      if not OutputOpened then
      begin
        Output_Memo.Visible:= false;
        Symbols_Memo.Visible:= false;
        Symbols_Button.Visible:= false;
        ViewGraphButton.Visible := false;
        Joule_Image.Visible := true;
        FigureButton2.Visible:=false;
        FigureForm.Visible:=false;
      end else
        Output_Memo.Visible:=true;
      if CalcDone then  with DMEnDrain do
      begin
        Output_Memo.Visible := false;
        Joule_Image.Visible := false;
        FileName := ChangeFileExt (FileName,'.out');
        if RunTimeError then
        begin
          ErrorFileName := 'Error.lst';
          AssignFile (ErrorFile,ErrorFileName);
          reset (ErrorFile);
          Output_Memo.Lines.Clear;
          while not eof (ErrorFile) do
          begin
            readln (ErrorFile,TextLine);
            Output_Memo.Lines.Add(TextLine);
          end;
          Output_Memo.Lines.Add('');
          closefile (ErrorFile);
          deletefile ('Error.lst');
        end else
        begin
          Read_Output_Lines(FileName);
          Output_Memo.Lines.Clear;
          Output_Memo.Visible := false;
          for k:=1 to NrOfLines do
              Output_Memo.Lines.Add(FileLine[k-1]);
          ViewGraphButton.Visible := true;
          OutputOpened := true;
          Symbols_Button.Visible := true;
          FigureButton2.Visible:=true;
        end;
        Output_Memo.Visible:= true;
      end; {if CalcDone then}
end; {TMainForm.Output_TabSheetShow}
{----------------------------------}


{see also OutputOpenExecute in Group MenuBar buttons, activated when
 clicking on the SeeOutput_Button}


procedure TMainForm.CloseOutput_ButtonClick(Sender: TObject);
{-----------------------------------------------------------}
begin
  inherited;
  Output_Memo.Visible  := false;
  Symbols_Memo.Visible := false;
  Joule_Image.Visible := true;
end;{TMainForm.CloseOutput_ButtonClick}
{-------------------------------------}



procedure TMainForm.Symbols_ButtonClick(Sender: TObject);
{-------------------------------------------------------}
begin
  inherited;
  Symbols_Memo.Visible := not Symbols_Memo.Visible;
  If Symbols_Memo.Visible then
      Symbols_Button.Caption := 'Close symbols'
  else
      Symbols_Button.Caption := 'Symbols';
end; {TMainForm.Symbols_ButtonClick}
{----------------------------------}



procedure TMainForm.FigureButton2Click(Sender: TObject);
begin
  inherited;
  FigureForm.Visible:=true;
end;



procedure TMainForm.ViewGraphButtonClick(Sender: TObject);
{--------------------------------------------------------}
begin
  inherited;
  OutputOpened := true;
  GraphImage.Visible := true;
  SaveGraphButton.Visible := true;
  BlWhButton.Visible := true;
  GraphOpened := true;
  PictureImage.Visible := false;
  JouleImage2.Visible := false;
  DMEnDrain.Read_Output_Data (DMEnDrain.FileName);
  if DMEnDrain.NrOfData<3 then
     Showmessage (' The drain spacing is very short. Graphs cannot me made.')
  else
  begin
    Show_Graphics;
    Graphics_Tabsheet.Show;
  end;
end; {TMainForm.ViewGraphButtonClick}
{-----------------------------------}


{******************************************************************************
 End of Output tabsheet, start of Graphics Tabsheet
*******************************************************************************}


procedure TMainForm.Graphics_TabSheetShow(Sender: TObject);
{---------------------------------------------------------}
begin
  inherited;
  Statustext ('Graphics presentations of output data can be seen and saved.'+
              ' Use "Make graph" to open an output file and see the graphs.');
  FigureForm.Visible:=false;
  if not GraphOpened then JouleImage2.Visible := true;
  Color:=true;
end; {TMainForm.Graphics_TabSheetShow}
{------------------------------------}



procedure TMainForm.MakeGraphics_ButtonClick(Sender: TObject);
{------------------------------------------------------------}
begin Inherited;
    SaveGraphButton.Visible := true;
    BlWhButton.Visible := true;
    Symbols_Memo.Visible := false;
    Output_Memo.Hide;
    if MainForm.OutputOpen_Dialog.Execute then  with DMEnDrain do
    begin
      Filename := MainForm.OutputOpen_Dialog.Files.Strings[0];
      if FileExists (Filename) then
         Read_Output_Data(Filename)
      else
      begin
        Showmessage ('File does not exist, please select another one,');
        exit;
      end;
    end
    else
    begin
      Showmessage('No output file was selected');
      exit;
    end;
    GraphImage.Visible:=true;
    PictureImage.Visible := false;
    Show_Graphics;
end;{TMainForm.MakeGraphics_ButtonClick}
{--------------------------------------}



procedure TMainForm.Show_Graphics;
{--------------------------------}
var DumReal : real; NameStr : string;
    ii : integer;
    XdataRel,YdataRel,ZdataRel: real;
    myRect : TRect;
begin
  GraphOpened := true;
  JouleImage2.Visible := false;
  MaxMin;
  Scaling;
  Relative;
  Legends;
  With GraphImage.Canvas do with DMEnDrain do
  begin
    Brush.Color := clWhite;
    FillRect(GraphImage.Canvas.ClipRect);
//    Font.Size := 12;
    Font.Size := 10;
    Font.Color := clBlack;
    Font.Name := 'Arial';
    Brush.Color:=clSilver;
    myRect:= Rect(0,0,623,465);
    FillRect (myRect);
    Textout (PosX1+8,0,Title1);
//    Font.Size := 12;
    Font.Size := 8;
    TextOut (20,PosY2+55,'EnDrain program at www.waterlog.info/endrain.htm');
    Brush.Color := $8B0000;
    if not Color then Brush.Color := clwhite;
    myRect:= Rect(20,19,605,445);
    FillRect (myRect);
    Pen.Style := psSolid;
    Pen.Color := clWhite;        {for the lines}
    if not Color then Pen.Color:=clBlack;
    Pen.Width := 1;
//    Pen.Width := 2;

    Font.Color := clYellow;
    if not Color then Font.Color:=clblack;
    Textout (PosX1+10,20,Title2);
    Font.Color := clWhite;
    if not Color then Font.Color:=clblack;

    Textout (470,PosY2+25,LegendX);
    TextOut (PosX1,50,LegendY);
    font.Color:=claqua;
    if not Color then font.Color:=clblack;
    Textout (PosX1+12,65,LegendY1);
    font.Color:=clwhite;
    if not Color then font.Color:=clblack;
    Textout (PosX1+16,80,LegendY2);
    font.Color:=clyellow;
    if not Color then font.Color:=clblack;
    if Sign<>' Hyd' then Textout (PosX1+16,95,LegendZ);
(*
    Textout (420,PosY2+30,LegendX);
    TextOut (PosX1,50,LegendY);
    font.Color:=claqua;
    if not Color then font.Color:=clblack;
    Textout (PosX1+12,70,LegendY1);
    font.Color:=clwhite;
    if not Color then font.Color:=clblack;
    Textout (PosX1+16,90,LegendY2);
    font.Color:=clyellow;
    if not Color then font.Color:=clblack;
    if Sign<>' Hyd' then Textout (PosX1+16,110,LegendZ);
*)
    font.Color:=clwhite;
    if not Color then font.Color:=clblack;
    moveto (PosX1,PosY2);                                            {the axes}
    lineto (PosX1,PosY1);
    moveto (PosX1,PosY2);
    lineto (PosX2,PosY2);

    for ii:=0 to ScaleY do                                    { vertical axis }
    begin
      Moveto (posX1,round(posY1+(ii/ScaleY)*LY));
      Lineto (posX1-4, round(posY1+(ii/ScaleY)*LY));
      DumReal := ii/ScaleY*(MaxY-MinY);
      NameStr := format('%' + IntToStr(2 + decimY) + '.' +
                        IntToStr(decimY) + 'f', [MaxY - DumReal]);
                 {bijv. '%3.1f' voor 1 decimaal, 3 cijfers, float number}
      Textout ((posX1-TextWidth(NameStr)-6),
              (round(posY1+(ii/ScaleY)*LY)-round(1/2*TextHeight(NameStr))),
               NameStr);
    end;
                                                            { horizontal axis }
    for ii:=0 to ScaleX do
    begin
      Moveto(round(posX1+(ii/ScaleX)*LX), posY2);
      Lineto(round(posX1+(ii/ScaleX)*LX), PosY2+4);
      DumReal := ii*(MaxX-MinX)/ScaleX;
      NameStr := format('%' + IntToStr(2 + decimX) + '.' +
                        IntToStr(decimX) + 'f', [MinX+DumReal]);
      Textout (round(posX1-8+(ii/ScaleX)*LX), PosY2+12, NameStr);
    end;
                                                   {plotting of curves}
    Pen.Color:=clyellow;
    if not Color then Pen.Color:=clblack;
    Pen.Style:=psdot;
    if (Sign=' Ene') and (NrOfData>9) then
       for ii:=2 to NrOfData-1 do
       begin
         moveto (RelXdata[ii-1],RelZdata[ii-1]+8);
         lineto (RelXdata[ii],RelZdata[ii]+8);
      end;
    if (Sign=' Ene') and (NrOfData<10) then
       for ii:=1 to NrOfData-1 do
       begin
         moveto (RelXdata[ii-1],RelZdata[ii-1]+8);
         lineto (RelXdata[ii],RelZdata[ii]+8);
       end;
    if (Sign=' Dar') and (NrOfData>9) then
       for ii:=2 to NrOfData-1 do
       begin
         moveto (RelXdata[ii-1],RelYdata[ii-1]+8);
         lineto (RelXdata[ii],RelYdata[ii]+8);
       end;
    if (Sign=' Dar') and (NrOfData<10) then
       for ii:=1 to NrOfData-1 do
       begin
         moveto (RelXdata[ii-1],RelYdata[ii-1]+8);
         lineto (RelXdata[ii],RelYdata[ii]+8);
       end;
                                                    {plotting of points}
    for ii:=1 to NrOfData do
    begin XdataRel := LX * (Xdata[ii-1] - MinX) /(MaxX-MinX);
                  RelXdata[ii-1] := PosX1+round(XdataRel);
                  YdataRel := LY*(Ydata[ii-1]-MinY)/(MaxY-MinY);
                  RelYdata[ii-1] := PosY2-round(YdataRel)-10;
                  ZdataRel := LY*(Zdata[ii-1]-MinY)/(MaxY-MinY);
                  RelZdata[ii-1] := PosY2-round(ZdataRel)-10;
    end;
    if NrOfData>9 then
    begin
      font.Color:=claqua;
      if not Color then font.Color:=clblack;
              for ii:=4 to NrOfData do
                  Textout (RelXdata[ii-1],RelYdata[ii-1],'x');
      font.Color:=clwhite;
      if not Color then font.Color:=clblack;
              for ii:=2 to NrOfData do
                    Textout (RelXdata[ii-1],RelZdata[ii-1],'o');
    end else
    begin
      font.Color:=claqua;
      if not Color then font.Color:=clblack;
      for ii:=2 to NrOfData do
          Textout (RelXdata[ii-1],RelYdata[ii-1],'x');
      font.Color:=clwhite;
      if not Color then font.Color:=clblack;
      for ii:=1 to NrOfData do
          Textout (RelXdata[ii-1],RelZdata[ii-1],'o');
    end;
  end; {with GraphImage.canvas}
//restoring Y and Z values
  for ii:=1 to DMEnDrain.NrOfData do
  begin
    DMEnDrain.Ydata[ii-1]:=DMEnDrain.Ydata[ii-1]/FactorY;
    DMEnDrain.Zdata[ii-1]:=DMEnDrain.Zdata[ii-1]/FactorY;
  end;
  GraphImage.Visible:=true;
end; {Show_Graphics}
{------------------}



procedure TMainForm.SaveGraphButtonClick(Sender: TObject);
{--------------------------------------------------------}
var Result : boolean;
    FigureFile : string;
begin
  inherited;
  Color:=true;
  Show_Graphics;
  if GraphSave_Dialog.Execute then
  begin
    FigureFile := GraphSave_Dialog.Files.Strings[0];
    if FileExists(FigureFile) then
       Result := DMEnDrain.Question('The file already exists, overwrite?')
    else Result := true;
    if Result then
    begin
      GraphImage.Picture.SaveToFile(FigureFile);
      Showmessage ('The graph was saved in  ' + FigureFile);
    end;
  end
  else Showmessage ('The graph was not saved');
end; {TMainForm.SaveGraphButtonClick}
{-----------------------------------}


procedure TMainForm.BlWhButtonClick(Sender: TObject);
var Result : boolean;
    FigureFile : string;
begin
  inherited;
  Color:=false;
  Show_Graphics;
  if GraphSave_Dialog.Execute then
  begin
    FigureFile := GraphSave_Dialog.Files.Strings[0];
    if FileExists(FigureFile) then
       Result := DMEnDrain.Question('The file already exists, overwrite?')
    else Result := true;
    if Result then
    begin
      GraphImage.Picture.SaveToFile(FigureFile);
      Showmessage ('The graph was saved in  ' + FigureFile);
    end;
  end
  else Showmessage ('The graph was not saved');
end;


{******************************************************************************
 End of Graphics tabsheet, start of Menubar buttons,
 ******************************************************************************}

{Action FileOpen}

procedure TMainForm.InputOpenExecute(Sender: TObject);
{----------------------------------------------------}
var   k: 0..NumDat; PresentDir : string;
begin Inherited;
  with DMEnDrain do
  begin
    if MainForm.InputOpen_Dialog.Execute then
    begin
      Filename := MainForm.InputOpen_Dialog.Files.Strings[0];
      if FileExists (Filename) then
         Read_InputFile
      else
      begin
        Showmessage ('File does not exist, please select another one,');
        exit;
      end;
    end
    else
    begin
      ShowMessage('No input file was selected');
      exit;
    end;
    Filename_Edit.Text := FileName;
    Filename_Edit.Show;
    FileName_Label.Show;
    For k := 0 to 3 do
        if Code = code_array[k] then
        begin
          CalcAim_ComboBox.ItemIndex := k;
          Break;
        end;
    AimOfCalc:=CalcAim_ComboBox.ItemIndex;
    RechargeButton.Enabled:=true;
    if AimOfCalc=1 then RechargeButton.Enabled:=false;
    if Method='Dar' then
    begin
       Method_Combobox.ItemIndex:=1;
       CalcMethod:='Darcy';
    end else
    begin
       Method_Combobox.ItemIndex:=0;
       CalcMethod:='Energ';
    end;
    For k := 1 to NumDat
    do  MaskEdit[k-1].Text := FloatToStr(DataR[k-1]);
    SetDataLineStandards;
    SetInitialValues;
    Title1_Edit.Text:=Title1;
    Title2_Edit.Text:=Title2;
  end; {with DMEnDrain do}
  InputOpened := true;
  Output_Memo.Visible:=false;
  Joule_Image.Visible := true;
  PresentDir:=GetCurrentDir;
  SetInitialDir (PresentDir);
  Input_TabSheet.Show;
end; {TMainForm.InputOpenExecute}
{-------------------------------}



procedure TMainForm.InputSaveExecute (Sender: TObject);
{-----------------------------------------------------}
label 1;
var DataOK, Result   : boolean;
    k                : 1..NumDat;
    i, Count         : byte;
    TmpTxt           : textfile;
    OutName, AuxFile : string;
begin Inherited;
   with DMEnDrain do
   begin
1:    if (SetAndVerifySaveName) and not NoSave then
      begin
        AuxFile := ExtractFileName (FileName);
(*
        if length(AuxFile)>28 then
        begin
          showmessage('The file name cannot have more than 24 characters.'+
                      ' Please rename.');
          goto 1;
        end;
        Count:=0;
        for i:=1 to length(AuxFile) do
            if AuxFile[i]=' ' then Count:=Count+1;
        if Count>0 then
        begin
          showmessage('The file name cannot include blank spaces.'+
                      ' Please rename');
          goto 1;
        end;
*)
        Count:=0;
        for i:=1 to length(AuxFile) do
            if AuxFile[i]='.' then Count:=Count+1;
        if Count>1 then
        begin
          Showmessage ('The number of dots (.) in the file name'+
                       ' should not be greater than 1. Please adjust.');
          goto 1;
        end;
        Title1 := Title1_Edit.Text;
        Title2 := Title2_Edit.Text;
        if not InputOpened then SetLength (DataR,NumDat);
        if DMEnDrain.Code='Con' then
        begin
          for i:=0 to 6 do
              DataR[i]:= StringToFloat(MaskEdit[i+2].Text);
              DataR[7]:= StringToFloat(MaskEdit[9].Text);
              DataR[8]:= StringToFloat(MaskEdit[10].Text);
          for i:=9 to NumDat-1 do
              DataR[i]:= 0;
        end else
        for k := 1 to NumDat do
        Try
           DataR[k-1]:= StringToFloat(MaskEdit[k-1].Text);
           Except on E: exception do
           begin
             ShowMessage ('There are invalid entries');
             DecimalSeparator := InitDecSep;
             exit;
           end;
        end;
        DecimalSeparator := InitDecSep;
        CheckData(DataOK);
        if DataOK then
        begin
          if Method_ComboBox.ItemIndex=0 then
             Method:='Ene'
          else
             Method:='Dar';
          AuxFile := ChangeFileExt(FileName,'.inp');
          Write_InputFile(AuxFile);
        end
        else exit;
      end
      else
      begin
        Showmessage ('The input data were not saved');
        exit;
      end;
      if not FileExists (FileName) then
      begin
        AssignFile (TmpTxt,FileName);
        rewrite (TmpTxt);
        closefile (TmpTxt);
      end;
      Write_InputFile(FileName);
      Result := Question('The input data were saved in  '+ FileName +
                         ' . Do you wish to do the calculations?');
      if not Result then
      begin
        Showmessage ('The calculations were not made, output is not available');
        exit;
      end;
      DoCalculations;
      AuxFile := ChangeFileExt(FileName,'.inp');
      OutName := ChangeFileExt(FileName,'.out');
   end; {with DMEnDrain do}
   showmessage ('The calculations were made and the output is found in'
                + OutName +
                ' . Proceed to the output tabsheet to see the results');
   WaitMemo.Visible:=false;
   Color:=true;
   Output_Tabsheet.Show;
end; {TMainForm.FileSaveExecute}
{------------------------------}



procedure TMainForm.OutputOpenExecute(Sender: TObject);
{-----------------------------------------------------}
var k : integer;
    PresentDir : string;
begin
  inherited;
    Output_Memo.Hide;
    Color:=true;
    with DMEnDrain do
    begin
      if MainForm.OutputOpen_Dialog.Execute then
      begin
        Filename := MainForm.OutputOpen_Dialog.Files.Strings[0];
        if FileExists (Filename) then
           Read_Output_Lines(Filename)
        else
        begin
          Showmessage ('File does not exist, please select another one,');
          exit;
        end;
      end
      else
      begin
        Showmessage('No output file was selected');
        exit;
      end;
      StatusText ('The output file can be imported into spreadsheets');
      Output_Memo.Lines.Clear;
      for k:=1 to NrOfLines do
      begin
        Output_Memo.Lines.Add(FileLine[k-1]);
      end;
    end; {with DMEnDrain do}
    PresentDir:=GetCurrentDir;
    SetInitialDir (PresentDir);
    Output_Memo.Show;
    Joule_Image.Hide;
    ViewGraphButton.Visible := true;
    OutputOpened := true;
    Symbols_Button.Visible := true;
    FigureButton2.Visible:=true;
    Output_Tabsheet.Show;
end; {TMainForm.OutputOpenExecute}
{--------------------------------}



procedure TMainForm.GraphOpenExecute(Sender: TObject);
{----------------------------------------------------}
var PresentDir, FigureFile : string;
begin
  inherited;
      if MainForm.GraphOpen_Dialog.Execute then
      begin
        FigureFile := MainForm.GraphOpen_Dialog.Files.Strings[0];
        if FileExists (FigureFile) then
          PictureImage.Picture.LoadFromFile(FigureFile)
        else
        begin
          Showmessage ('File does not exist, please select another one,');
          exit;
        end;
      end
      else
      begin
        Showmessage('No graphics file was selected');
        exit;
      end;
      JouleImage2.Visible := false;
      GraphImage.Visible := false;
      SaveGraphButton.Visible := false;
      BlWhButton.Visible := false;
      SaveGraphButton.Visible := false;
      PictureImage.Visible := true;
      GraphOpened:=true;
      PresentDir:=GetCurrentDir;
      SetInitialDir (PresentDir);
      Graphics_Tabsheet.Show;
end; {TMainForm.GraphOpenExecute}
{-------------------------------}


{******************************************************************************
 End of Menubar buttons, start Group MainForm Routines
 ******************************************************************************}


procedure TMainForm.FormCreate(Sender: TObject);
{----------------------------------------------}
var   k: 0..NumDat;
      InitDir : string;
begin Inherited;
      PageControl1.ActivePageIndex := 0;     {Introduction tabsheet}
      getdir (0,InitDir);
{      InitDir:=Getcurrentdir;                alternative}
      SetInitialDir (InitDir);
      InputSave.Enabled := false;
      OutputOpened := false;
      InputOpened := false;
      GraphOpened := false;
      CalcDone := false;
      CalcAim_ComboBox.ItemIndex := 0;
      Method_ComboBox.ItemIndex := 0;
      AimOfCalc:=0;
      DepthM   := '0';
      DepthI := '0';
      DepthD := '0';
      Depth1 := '0';
      DepthW := '0';
      Recharge := '0';
      Spacing  := '0';
      HorCondA := '0';
      HorCond1 := '0';
      VertCond1 := '0';
      HorCond2 := '0';
      VertCond2 := '0';
      Recharge := '0';
      ResE := '0';
      WidthW := '0';
      CalcMethod := 'Energ';
      SetLength(MaskEdit, NumDat);
      For k := 0 to NumDat - 1 do
      begin MaskEdit[k] := TMaskEdit.Create(self);
            MaskEdit[k].Parent := Input_TabSheet;
            MaskEdit[k].Left := 512;
            MaskEdit[k].Text := '0';
            MaskEdit[k].OnExit := MaskEdit1Exit;
            if k = 0 then
               MaskEdit[0].Top := 132
            else
               MaskEdit[k].Top := MaskEdit[k - 1].Top + 20;
      end;
      MaskEdit[1].OnExit:=MaskEdit2Exit;
      MaskEdit[2].OnExit:=MaskEdit2Exit;

      LX := posX2-posX1;
      LY := posY2-posY1;
      Left := 50;
      if screen.Width > 860 then
         Width := 760
      else if screen.Width < width then
      begin
         Left := 5;
         Width := screen.Width-5;
      end;
      InitDecSep := DecimalSeparator;
end; {TMainForm.FormCreate}
{-------------------------}



procedure TMainForm.FormDestroy(Sender: TObject);
{-----------------------------------------------}
var   k: 0..NumDat;
begin Inherited;
      For k := 0 to NumDat - 1
      do    MaskEdit[k].Free;
end; {TMainForm.FormDestroy}
{--------------------------}



procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
{-----------------------------------------------------------------------}
begin Inherited;
      Action := caNone;
      CloseForm.Show;
end; {TMainForm.FormClose}
{------------------------}



procedure TMainForm.FormShow(Sender: TObject);
{--------------------------------------------}
begin Inherited;
      If CloseForm.Visible then
            Application.Terminate;
end; {TMainForm.FormShow}
{-----------------------}


end.

